﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using ProjectBoat_bae.DrawningObjects;
using ProjectBoat_bae.Entities;

namespace ProjectBoat_bae.Generics
{
    internal class BoatCompareByColor : IComparer<Drawningboat?>
    {
        public int Compare(Drawningboat? x, Drawningboat? y)
        {

            if (x == null || x.EntityBoat == null)
                throw new NotImplementedException(nameof(x));

            if (y == null || y.EntityBoat == null)
                throw new NotImplementedException(nameof(y));

            var bodyColor = x.EntityBoat.BodyColor.Name.CompareTo(y.EntityBoat.BodyColor.Name);

            if (bodyColor != 0) return bodyColor;

            if (x.EntityBoat is EntityMotorBoat &&
                y.EntityBoat is EntityMotorBoat)
            {
                var addcolor = (x.EntityBoat as EntityMotorBoat).AdditionalColor.Name.CompareTo((y.EntityBoat
                    as EntityMotorBoat).AdditionalColor.Name);
                if (addcolor != 0) return addcolor;
            }
            return 1;
        }
    }
}
