﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using ProjectBoat_bae.DrawningObjects;
namespace ProjectBoat_bae.Generics
{
    internal class BoatCompareByType : IComparer<Drawningboat?>
    {
        public int Compare(Drawningboat? x, Drawningboat? y)
        {
            if (x == null || x.EntityBoat == null)
            {
                throw new ArgumentNullException(nameof(x));
            }
            if (y == null || y.EntityBoat == null)
            {
                throw new ArgumentNullException(nameof(y));
            }
            if (x.GetType().Name != y.GetType().Name)
            {
                return x.GetType().Name.CompareTo(y.GetType().Name);
            }
            var speedCompare = x.EntityBoat.Speed.CompareTo(y.EntityBoat.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return x.EntityBoat.Weight.CompareTo(y.EntityBoat.Weight);
        }
    }
}
