﻿using System;
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ProjectBoat_bae.DrawningObjects;
using ProjectBoat_bae.Entities;

namespace ProjectBoat_bae.Generics
{
    internal class DrawingBoatEqutables : IEqualityComparer<Drawningboat?>
    {
        public bool Equals(Drawningboat? x, Drawningboat? y)
        {
            if (x == null || x.EntityBoat == null)
                throw new ArgumentNullException(nameof(x));

            if (y == null || y.EntityBoat == null)
                throw new ArgumentNullException(nameof(y));
            if (x.GetType().Name != y.GetType().Name)
                return false;
            if (x.EntityBoat.Speed != y.EntityBoat.Speed)
                return false;
            if (x.EntityBoat.Weight != y.EntityBoat.Weight)
                return false;
            if (x.EntityBoat.BodyColor != y.EntityBoat.BodyColor)
                return false;
            // to do logic for "сравнения" additional parameters :)
            if (x is DrawningMotorBoat && y is DrawningMotorBoat)
            {
                if ((x.EntityBoat as EntityMotorBoat).AdditionalColor != (y.EntityBoat as EntityMotorBoat).AdditionalColor)
                {
                    return false;
                }
                if ((x.EntityBoat as EntityMotorBoat).Body != (y.EntityBoat as EntityMotorBoat).Body)
                {
                    return false;
                }
                if ((x.EntityBoat as EntityMotorBoat).Wing != (y.EntityBoat as EntityMotorBoat).Wing)
                {
                    return false;
                }
            }

            return true;
        }

        public int GetHashCode([DisallowNull] Drawningboat obj)
        {
            return obj.GetHashCode();
        }
    }
}

