﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectBoat_bae.MovementStrategy
{
    public class MoveToBorder : AbstractStrategy
    {
        protected override bool IsTargetDestinaion()
        {
            var objParams = GetObjectParameters;
            if (objParams == null)
            {
                return false;
            }
            return objParams.RightBorder <= FieldWidth &&
                objParams.RightBorder + GetStep() >= FieldWidth &&
                objParams.DownBorder <= FieldHeight &&
                objParams.DownBorder + GetStep() >= FieldHeight;

        }
        protected override void MoveToTarget()
        {
            var objParams = GetObjectParameters;
            if (objParams == null)
            {
                return;
            }
            var diffX = FieldWidth - objParams.RightBorder;
            if (Math.Abs(diffX) > GetStep())
            {
                MoveRight();
            }
            var diffY = FieldHeight - objParams.DownBorder;
            if (Math.Abs(diffY) > GetStep())
            {
                MoveDown();
            }
        }
    }
}
